VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.UserControl ProgBars 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.PictureBox picBack 
      Height          =   1815
      Left            =   0
      ScaleHeight     =   1755
      ScaleWidth      =   4515
      TabIndex        =   0
      Top             =   0
      Width           =   4575
      Begin VB.VScrollBar VScroll1 
         Height          =   1215
         Left            =   4200
         TabIndex        =   1
         Top             =   240
         Visible         =   0   'False
         Width           =   255
      End
      Begin MSComctlLib.ProgressBar prog 
         Height          =   375
         Index           =   0
         Left            =   0
         TabIndex        =   2
         Top             =   -400
         Visible         =   0   'False
         Width           =   1455
         _ExtentX        =   2566
         _ExtentY        =   661
         _Version        =   393216
         Appearance      =   1
      End
      Begin VB.Label lblProg 
         Height          =   255
         Index           =   0
         Left            =   0
         TabIndex        =   3
         Top             =   -655
         Visible         =   0   'False
         Width           =   1215
      End
   End
End
Attribute VB_Name = "ProgBars"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
                        
Private Const WM_USER = &H400
Private Const CCM_FIRST = &H2000                    ' Common control shared messages
Private Const CCM_SETBKCOLOR = CCM_FIRST + 1        ' lParam is bkColor
Private Const PBM_SETBKCOLOR = CCM_SETBKCOLOR       ' lParam = bkColor
Private Const PBM_SETBARCOLOR = WM_USER + 9         ' lParam = bar color
Private nProg As Long
Private arrProg() As Long
Private Declare Function SendMessage Lib "USER32.DLL" Alias "SendMessageA" (ByVal hWnd As Long, ByVal dwMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Sub picBack_Resize()
    With VScroll1
        .Top = 0
        .Height = picBack.ScaleHeight
        .Left = picBack.ScaleWidth - .Width
    End With
End Sub

Private Sub UserControl_Initialize()
    nProg = 0
    ReDim arrProg(0)
End Sub
Private Function StandardLabelTop(ByVal item As Long) As Long
    StandardLabelTop = (item - 1) * 655
End Function
Private Function StandardBarTop(ByVal item As Long) As Long
    StandardBarTop = StandardLabelTop(item) + 255
End Function
Private Sub PositionItems()
    Dim i As Long
    Dim backColor As Long
    
    On Error GoTo errSub
    For i = 1 To lblProg.Count - 1
        If VScroll1.Visible Then
            lblProg(i).Top = StandardLabelTop(i) - VScroll1.Value * 655
            prog(i).Top = StandardBarTop(i) - VScroll1.Value * 655
            lblProg(i).Width = picBack.ScaleWidth - 20 - VScroll1.Width
            prog(i).Width = lblProg(i).Width
        Else
            lblProg(i).Top = StandardLabelTop(i)
            prog(i).Top = StandardBarTop(i)
            lblProg(i).Width = picBack.ScaleWidth - 20
            prog(i).Width = lblProg(i).Width
        End If
        If (i Mod 2) = 0 Then
            backColor = vbGreen
        Else
            backColor = vbYellow
        End If
        lblProg(i).backColor = backColor
        SetProgressBarColors prog(i).hWnd, vbRed, backColor
    Next
ExitSub:
    Exit Sub
errSub:
    Debug.Print "Error in PositionItems: " & Err.Description
    Stop
End Sub

Private Sub ManageScrollbar()
    
    On Error GoTo errSub
    If prog(nProg).Top + prog(nProg).Height <= picBack.ScaleHeight Then
        'no scrollbar
        VScroll1.Visible = False
    Else
        'with scrollbar
        VScroll1.Visible = True
        VScroll1.Max = prog.Count - 1
    End If
    
ExitSub:
    PositionItems
    Exit Sub
errSub:
    Debug.Print "Error in ManageScrollbar: " & Format$(Err.Number)
    Resume ExitSub
    Resume
End Sub
Public Function AddProgressbar(ByVal Id As Long, ByVal sTarget As String) As Long
    On Error GoTo errSub
    nProg = nProg + 1
    Load lblProg(nProg)
    Load prog(nProg)
    lblProg(nProg).Caption = sTarget
    lblProg(nProg).Top = lblProg(nProg - 1).Top + 655
    prog(nProg).Top = prog(nProg - 1).Top + 655
    prog(nProg).Value = 0
    ManageScrollbar
    lblProg(nProg).Visible = True
    prog(nProg).Visible = True
    ReDim Preserve arrProg(nProg)
    arrProg(nProg) = Id
ExitSub:
    Exit Function
errSub:
    Debug.Print "Error in AddProgressbar: " & Format$(Err.Number)
    Resume ExitSub

End Function

Public Sub SetProgress(ByVal Id As Long, ByVal iValue As Long)
    Dim memb As Long
    On Error GoTo errSub
    If iValue < 0 Or iValue > 100 Then Exit Sub
    For memb = 1 To UBound(arrProg)
        If arrProg(memb) = Id Then
            Exit For
        End If
    Next
    If Not memb = 0 And UBound(arrProg) >= memb Then
        If prog.Count >= memb Then
            prog(memb).Value = iValue
        Else
            Debug.Print "Error: progressbar #" & memb & " is invalid"
        End If
    End If
ExitSub:
    Exit Sub
errSub:
    Debug.Print "Error in SetProgress: " & Format$(Err.Number)
    Resume ExitSub
    
End Sub

Public Function RemoveProgressbar(ByVal Id As Long) As Long
    'we need to shift the array after this member
    Dim memb As Long
    Dim i As Long
    On Error GoTo errSub
    For memb = 1 To UBound(arrProg)
        If arrProg(memb) = Id Then Exit For
    Next
    If Not memb = 0 Then
        For i = memb + 1 To nProg
            lblProg(i - 1).Caption = lblProg(i).Caption
            prog(i - 1) = prog(i)
            arrProg(i - 1) = arrProg(i)
        Next
        'remove the last
        Unload lblProg(nProg)
        Unload prog(nProg)
        nProg = nProg - 1
        ReDim Preserve arrProg(nProg)
        ManageScrollbar
    End If
ExitSub:
    Exit Function
errSub:
    Debug.Print "Error in RemoveProgressbar: " & Format$(Err.Number)
    Resume ExitSub
    
End Function

Private Sub UserControl_Resize()
    With picBack
        .Left = 0
        .Top = 0
        .Width = UserControl.ScaleWidth
        .Height = UserControl.ScaleHeight
    End With
End Sub

Private Sub UserControl_Terminate()
    Do While nProg > 0
        Unload lblProg(nProg)
        Unload prog(nProg)
        nProg = nProg - 1
    Loop
End Sub
Private Sub SetProgressBarColors(ByVal progHwnd As Long, ByVal barColor As Long, ByVal bkColor As Long)
    SendMessage progHwnd, PBM_SETBKCOLOR, 0, bkColor
    SendMessage progHwnd, PBM_SETBARCOLOR, 0, barColor
End Sub

Private Sub VScroll1_Change()
    PositionItems
End Sub

